<html>
<head>
    <title>DisplayBlocks</title>
	<style>
	table, td{
		border-collapse: collapse;
		border: 1px solid;
	}
	</style>
	<script src="https://cdnjs.cloudflare.com/ajax/libs/crypto-js/4.1.1/crypto-js.min.js" integrity="sha512-E8QSvWZ0eCLGk4km3hxSsNmGWbLtSCSUcewDQPQWZF6pEU8GlT8a5fF32wOl1i8ftdMhssTrF/OhyGWwonTcXA==" crossorigin="anonymous" referrerpolicy="no-referrer"></script>

	<script src="head.js"></script>
	<script>
	let disIdx = -1;
	
	//this clustering is different from other
	function clustering(){
		cluster = document.getElementById("clusterSel").value;
		disIdx = -1;
		loadJson(disIdx);
	}
	
	function countZeros(x){
		let i = 0;
		let ans = 0;
		for (i = 0; i < 14; i++){
			y = parseInt(x.substring(i, i+1), 16);
			//console.log(y);
			if(y < 1){
				ans += 4;
			}else{
				if(y < 2){
					ans += 3;
				}else if(y < 4){
					ans += 2;
				}else if(y < 8){
					ans += 1;
				}
				return ans;
			}
		}
	}
	
	async function hash(stringInput) {
		const utf8 = stringInput ; // new TextEncoder().encode(stringInput);
		console.log("utf8 : "+ utf8);
		const hashBuffer = CryptoJS.SHA256(utf8);// await window.crypto.subtle.digest('SHA-256', utf8);
		console.log("hashBuffer :" + hashBuffer );
		const hashArray = Array.from(new Uint8Array(hashBuffer));
		const hashHex = hashArray
			.map((bytes) => bytes.toString(16).padStart(2, '0'))
			.join('');
		return hashBuffer;
	}
	
	async function loadJson(disIdx){
		let rsp01 = await fetch('http://35.161.83.70:' + cluster + '/blockchain/blocks/') ;
		let jR01 = await rsp01.json();
		//console.log(jR01);
		
		
		if(disIdx == -1){
			disIdx = jR01.length - 1;
		}
		let blockTable = "<table><tr>";
		blockTable += "<tr><td>Index</td><td><select id='blockIndex' onchange='loadJson(this.value)'>";
		for (let i = jR01.length - 1; i >= 0 ; i--){
			blockTable += "<option value='" + i + "'>" + i + "</option>";
		}
		blockTable += "</select></td></tr>";
		let date = new Date(jR01[disIdx].timestamp * 1000);
		blockTable += "<tr><td>Timestamp</td><td>" + jR01[disIdx].timestamp + "&emsp;[" + date + "]</td></tr>";
		blockTable += "<tr><td>Prev Hash</td><td>" + jR01[disIdx].previousHash + "</td></tr>";
		blockTable += "<tr><td>Current Hash</td><td>" + jR01[disIdx].hash + "</td></tr>";
		let difficultyN = countZeros(jR01[disIdx].hash.substring(0, 14));
		//let difficulty = parseInt(jR01[disIdx].hash.substring(0, 14), 16);
		blockTable += "<tr><td>Difficulty</td><td>" + difficultyN + "</td></tr>";	// (" + difficulty + ")
		blockTable += "<tr><td>Nonce</td><td>" + jR01[disIdx].nonce + "</td></tr>";
		blockTable += "<tr><td>Merkle Root</td><td><span id='mrkRt'></span></td></tr>";
		blockTable += "<tr><td>Transactions</td><td>";	//(Table of transactions)
		jR01[disIdx].transactions.forEach(function(disBlkTx, index){
			blockTable += "<table><tr><td>index</td><td>" + index + "</td></tr>";
			blockTable += "<tr><td>id</td><td>" + disBlkTx.id + "</td></tr>";
			blockTable += "<tr><td>hash</td><td>" + disBlkTx.hash + "</td></tr>";
			blockTable += "<tr><td>type</td><td>" + disBlkTx.type + "</td></tr>";
			blockTable += "<tr><td>data</td><td>";
				blockTable += "<table><tr><td>Inputs</td><td>";
				if(disBlkTx.data.inputs != ""){
					disBlkTx.data.inputs.forEach(function(disInputTx, index, array){
						blockTable += "<table><tr><td>Tx id</td><td>" + disInputTx.transaction + "</td></tr>";
						blockTable += "<tr><td>Index</td><td>" + disInputTx.index + "</td></tr>";
						blockTable += "<tr><td>Amount</td><td>" + disInputTx.amount + "</td></tr>";
						blockTable += "<tr><td>Address</td><td>" + disInputTx.address + "</td></tr>";
						blockTable += "<tr><td>Signature</td><td>" + disInputTx.signature + "</td></tr></table>";
					});
				} else{
					blockTable += "null";
				}
				blockTable += "<tr><td>Outputs</td><td>";
				disBlkTx.data.outputs.forEach(function(disOutputTx, index, array){
					blockTable += "<table><tr><td>Amount</td><td>" + disOutputTx.amount + "</td></tr>";
					blockTable += "<tr><td>Address</td><td>" + disOutputTx.address + "</td></tr></table>";
				});
				blockTable += "</table>";
			blockTable += "</td></tr>";
			blockTable += "";
		});
		blockTable += "</td></tr></table>";
		
		document.getElementById("showBlock").innerHTML = blockTable;
		
		//dropdown pre-select the current block
		document.getElementById("blockIndex").getElementsByTagName('option')[jR01.length - 1 - disIdx].selected = "selected";
		
		
		//console.log(jR01[disIdx].transactions.length);
		let mrkRoot = "";
		let mrkRootL = "";
		let mrkRootR = "";
		let mrkRootLL = "";
		let mrkRootLR = "";
		let mrkRootRL = "";
		let mrkRootRR = "";
		if(jR01[disIdx].transactions.length >= 1){
			mrkRootLL = jR01[disIdx].transactions[0].hash;
			mrkRoot = mrkRootLL;
		}
		if(jR01[disIdx].transactions.length >= 2){
			mrkRootLR = jR01[disIdx].transactions[1].hash;
			mrkRootL = await hash(mrkRootLL + mrkRootLR);
			mrkRoot = mrkRootL;
		}
		if(jR01[disIdx].transactions.length >= 3){
			mrkRootRL = jR01[disIdx].transactions[2].hash;
			mrkRoot = await hash(mrkRootL + mrkRootRL);
		}
		if(jR01[disIdx].transactions.length == 4){
			mrkRootRR = jR01[disIdx].transactions[3].hash;
			mrkRootR = await hash(mrkRootRL + mrkRootRR);
			mrkRoot = await hash(mrkRootL + mrkRootR);
		}
		document.getElementById("mrkRt").innerHTML = mrkRoot;
	}
	//loadJson(disIdx);
	</script>
</head>
<body onload="printPageHeader()">
	<div id="jsHeader">
		Display (All /) Specific Blocks in the Chain
	</div>
	
	<!-- Structure example
	<table id="blocks">
	<tr><td>Index</td><td><span id="blockIndex"/></td></tr>
	<tr><td>Timestamp</td><td><span id="timestamp"/></td></tr>
	<tr><td>Prev Hash</td><td><span id="previousHash"/></td></tr>
	<tr><td>Current Hash</td><td><span id="currentHash"/></td></tr>
	<tr><td>Difficulty</td><td>(Difficulty)</td></tr>
	<tr><td>Nonce</td><td><span id="nonce"/></td></tr>
	<tr><td>Merkle Root</td><td>(Merkle Root)</td></tr>
	<tr><td>Transactions</td><td>
		(Table of transactions)
		<table>
		<tr><td>id</td><td>(id)</td></tr>
		<tr><td>hash</td><td>(hash)</td></tr>
		<tr><td>type</td><td>(type)</td></tr>
		<tr><td>data</td><td>
			(Data Table)
			<table>
			<tr><td>Inputs</td><td>
				(can be null,1,or many)
				<table>
				<tr><td>Txid</td><td>ididididid</td></tr>
				<tr><td>index</td><td>01234</td></tr>
				<tr><td>amount</td><td>1000000</td></tr>
				<tr><td>Address</td><td>(addr)</td></tr>
				<tr><td>Signature</td><td>(sign)</td></tr>
				</table>
			</td></tr>
			<tr><td>Outputs</td><td>
				(can be 1 or many)
				<table>
				<tr><td>amount</td><td>1000000</td></tr>
				<tr><td>Address</td><td>(addr)</td></tr>
				</table>
			</td></tr>
			</table>
		</td></tr>
		</table>
	</td></tr>
	</table>
	-->
	<br>
	<div id="showBlock">
		block showing here...
	</div>
</body>
</html>
